
        TITLE "PIC18F2620 INPUT-OUTPUT" 
        ;INPUT-OUTPUT.ASM  INSERIMENTO DI UN BYTE MEDIANTE DIP SWITCH E VISUALIZZAZIONE DELLO STESSO IN BINARIO

        #INCLUDE <p18f2620.inc>  
        CONFIG OSC = INTIO7,IESO = OFF ;programmazione del registro di configurazione CONFIG1H per l'attivazione dell'oscillatore interno con uscita Fosc/4 sul pin RA6
        ; e funzione di input/output sul pin RA7
        CONFIG LVP = OFF ;programmazione del registro di configurazione CONFIG4L per la disattivazione del pin 5 della porta B come ingresso di programmazione (PGM)

		ORG 0x0000 ; direttiva per il compilatore per il caricamento del programma a partire dalla locazione 0x0000
DATO    EQU 0x300  ; direttiva per il compilatore per l'assegnazione dell'indirizzo 0x300 (terzo banco di memoria) alla variabile dato
        MOVLB 3  ;selezione del banco di memoria 3 , da 0x300 a 0x3FF
        BSF OSCCON,6 ;ponendo a 1 i bit 4,5,6 del registro OSCCON, si seleziona la frequenza dell'oscillatore interno Fosc = 8 MHz
        BSF OSCCON,5
        BSF OSCCON,4
        BSF OSCCON,1 ;ponendo a 1 i bit 0,1 del registro OSCCON si seleziona l'oscillatore interno
        BSF OSCCON,0
		MOVLW 0x0F
		MOVWF ADCON1 ;programmazione del registro di selezione (ADCON1) delle linee A/D (ingressi analogici/ingressi-uscite digitali)
                     ;la combinazione PCGF3 = 1, PCGF2 = 1, PCGF1 = 1, PCGF0 = 1 predispone come ingressi-uscite digitali le linee 
                     ;AN0,AN1,AN2,AN3,AN4,AN8,AN9,AN10,AN11,AN12
		MOVLW 0xFF ;oppure 0b11111111
		MOVWF TRISB ;predisposizione di tutte le linee di input/output della porta B come ingressi,da collegare al DIP SWITCH

		MOVLW 0x00 ;oppure 0b00000000
		MOVWF TRISC ;predisposizione di tutte le linee di input/output della porta C come uscite,da collegare ai LED
        BCF INTCON2,7 ;abilitazione dei resistori interni di pull-up della porta B 
        CLRF LATC ; azzeramento del latch della porta C
INPUT
		MOVFF PORTB,DATO ;lettura del dato inserito mediante il DIP SWITCH collegato agli ingressi della porta B 
		MOVFF DATO,LATC ; visualizzazione del dato mediante i LED collegati al latch LATC della porta 
		GOTO INPUT                    
        END
