        TITLE "PIC18F2620 SQUAREWAVE" 
;squarewave.asm   GENERAZIONE DI ONDE QUADRE

#INCLUDE <p18f2620.inc> 

;Direttive di configurazione per l'assemblatore
        CONFIG OSC=INTIO7 ,IESO=ON ; abilitazione dell'oscillatore interno, Fosc = 125 KHz
        CONFIG LVP=OFF ;disabilitazione della linea PGM/PB5 per la programmazione Low Voltage Programming ed abilitazione della linea PB5 della porta B come ingresso/uscita
        
		ORG 0x0000 ; allocazione del programma a partire dalla locazione iniziale della memoria EEPROM flash
		MOVLB 2    ; selezione del banco di memoria N. 2, da 0x200 a 0x2FF
COUNTER1 EQU 0x200  ;allocazione in memoria dei contatori per la subroutine di ritardo
COUNTER2 EQU 0x201
COUNTER3 EQU 0x202
;Selezione della frequenza dell'oscillatore interno
;BCF OSCCON,6 ; BCF BIT 6 CLEAR  -> BIT 6 = 0
;BCF OSCCON,5 ; BSF BIT 5 SET    -> BIT 5 = 0
;BSF OSCCON,4 ; BCF BIT 4 CLEAR  -> BIT 4 = 1
;variazione della frequenza dell'oscillatore 
; (bit 6,5,4 del registro OSCCON) 
;	l l l 	8 MHz 
;	l l 0 	4 MHz 
;	l 0 l 	2 MHz 
;	l 0 0 	l MHz 
;	0 l l 	500 KHz 
;	0 l 0 	250 KHz 
; 	0 0 l 	125 KHz 
;Si sceglie la combinazione 001 -> Fosc = 125 KHz 

		BCF OSCCON,6 ;ponendo a 001 i bit 6,5,4 del registro OSCCON, si seleziona la frequenza dell'oscillatore interno Fosc = 125 KHz  
		             ;Tck (periodo di clock) = 1/Fosc = 1/125E3 = 8E-6 s ; Tcy (durata ciclo istruzione) = 1/(Fosc/4) = 1/125000/4 = 3,2E-5 s
        BCF OSCCON,5
        BSF OSCCON,4
        BSF OSCCON,1 ;ponendo a 1 i bit 0,1 del registro OSCCON si seleziona l'oscillatore interno
        BSF OSCCON,0

		MOVLW 0x0F  
		MOVWF ADCON1 ;predisposizione delle linee AN0..AN12 come ingressi/uscite digitali
		MOVLW 0b00000001 ;oppure 0x01 - predisposizione della linea RB0 porta B come ingresso ,collegato all'interruttore di attivazione del generatore
		MOVWF TRISB
		MOVLW 0b01111111 ;oppure 0x7F - predisposizione della linea RC7 della porta C come uscita del generatore di onde quadre
		MOVWF TRISC 
		CLRF LATC ; azzeramento del latch della porta C
		BCF INTCON2,7 ; abilitazione dei resistori interni di pull up della porta B
START   BTFSS PORTB,0 ;ciclo polling per l'abilitazione della generazione dell' onda quadra mediante un contatto normalmente chiuso
		GOTO START 
		BSF LATC,7 ; generazione del livello alto dell'onda quadra
		CALL DELAYLONG  ; ritardo pari al semiperiodo T/2
		BCF LATC,7 ; generazione del livello basso dell'onda quadra
		CALL DELAYLONG ; ritardo pari al semiperiodo T/2
		GOTO START 


DELAYSHORT MOVLW 0xFF
LOOP4      MOVWF COUNTER1
           DECF COUNTER1
           BNZ LOOP4
           RETURN

 
DELAYLONG	MOVLW 0x0F ;  byte di controllo della frequenza dell'onda quadra      
	        MOVWF COUNTER1
LOOP1       MOVWF COUNTER2
LOOP2       MOVWF COUNTER3     
LOOP3       DECF COUNTER3
	        BNZ LOOP3
	        DECF COUNTER2      
			BNZ LOOP2 
	        DECF COUNTER1 		
			BNZ LOOP1
			RETURN 
			
			
	      	END